import { Component, AfterViewInit, Input } from '@angular/core';
import { Router } from '@angular/router';
import { Language } from 'angular-l10n';

@Component({
  selector: 'of-tabbar',
  templateUrl: './app.tabbar.component.html',
})
export class TabbarComponent implements AfterViewInit {
  @Input() tabs: any;

  constructor(public router: Router) { }

  ngAfterViewInit() {
  }

  handleChange(event) {
    const path: string = this.tabs[event.index].path;
    if (path.length === 0) { return; }
    this.router.navigate([path]);
  }
}
