// import { Component, OnInit, AfterViewInit, ViewChild } from '@angular/core';
// import { AfterContentInit } from '@angular/core/src/metadata/lifecycle_hooks';
// import { Router } from '@angular/router';
// import { Store, select } from '@ngrx/store';

// import { AuthSelector } from 'packages/member/store';
// import { RPCClientError } from '@loafer/ng-rpc/protocol';
// import { Domain } from 'packages/domain/model';

// import * as ListStore from '../../store/noauth-probe';
// import { NoAuthProbeSelector } from '../../store';
// import { NoAuthProbe } from '../../model';

// @Component({
//   selector: 'of-noauth-list',
//   templateUrl: './list.component.html',
//   styleUrls: ['./list.component.scss']
// })
// export class ListComponent implements OnInit, AfterContentInit {
//   noAuthProbes$ = this.store.pipe(select(NoAuthProbeSelector.select('noAuthProbes')));

//   selected: NoAuthProbe = null;

//   displayedColumns = ['select', 'id', 'description', 'createDate'];
//   dataSource: MatTableDataSource<NoAuthProbe>;
//   @ViewChild(MatSort) sort: MatSort;

//   constructor(
//     private router: Router,
//     private store: Store<ListStore.State>
//   ) {
//   }

//   ngAfterContentInit() {
//     this.store.select(AuthSelector.select('domain')).subscribe(
//       (domain: Domain) => {
//         this.store.dispatch(new ListStore.ReadAllByDomain(domain));
//       }
//     );

//     this.noAuthProbes$.subscribe(
//       (noAuthProbes: NoAuthProbe[]) => {
//         this.dataSource = new MatTableDataSource(noAuthProbes);
//         this.dataSource.sort = this.sort;
//       },
//       (error: RPCClientError) => {
//         console.log(error.response.message);
//       }
//     );
//   }



//   ngOnInit() {
//   }

//   handleSelect(selected: NoAuthProbe) {
//     this.selected = selected;
//   }

//   handleAccept() {
//     this.store.dispatch(new ListStore.Accept(this.selected));
//     this.noAuthProbes$.subscribe(
//       (noAuthProbes: NoAuthProbe[]) => {
//         this.dataSource = new MatTableDataSource(noAuthProbes);
//         this.dataSource.sort = this.sort;
//       },
//       (error: RPCClientError) => {
//         console.log(error.response.message);
//       }
//     );
//     console.log(this.selected.id + ' accept');
//   }

//   handleDeny() {
//     this.store.dispatch(new ListStore.Deny(this.selected));
//     this.noAuthProbes$.subscribe(
//       (noAuthProbes: NoAuthProbe[]) => {
//         this.dataSource = new MatTableDataSource(noAuthProbes);
//         this.dataSource.sort = this.sort;
//       },
//       (error: RPCClientError) => {
//         console.log(error.response.message);
//       }
//     );
//     console.log(this.selected.id + ' deny');
//   }
// }
